Scala Standard Library2.13.0 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package math

  The package object `scala.math` contains methods for performing basic numeric operations such as elementary exponential, logarithmic, root and trigonometric functions.

  The package object `scala.math` contains methods for performing basic numeric operations such as elementary exponential, logarithmic, root and trigonometric functions.

  All methods forward to java.lang.Math unless otherwise noted.

  Definition Classes
    scala
  See also

    java.lang.Math

-  object Numeric extends java.io.Serializable

  Definition Classes
    math
  Since

    2.8

- BigDecimalAsIfIntegral
- BigDecimalIsConflicted
- BigDecimalIsFractional
- BigIntIsIntegral
- ByteIsIntegral
- CharIsIntegral
- DoubleIsFractional
- ExtraImplicits
- FloatIsFractional
- Implicits
- IntIsIntegral
- LongIsIntegral
- ShortIsIntegral

o

scala.math.Numeric

# CharIsIntegral

###
Companion trait CharIsIntegral

#### implicit object CharIsIntegral extends CharIsIntegral with CharOrdering

Source
  Numeric.scala

Linear Supertypes
CharOrdering, CharIsIntegral, Integral[Char], Numeric[Char], Ordering[Char], PartialOrdering[Char], Equiv[Char], java.io.Serializable, Comparator[Char], AnyRef, Any
Content Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. CharIsIntegral
2. CharOrdering
3. CharIsIntegral
4. Integral
5. Numeric
6. Ordering
7. PartialOrdering
8. Equiv
9. Serializable
10. Comparator
11. AnyRef
12. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  class IntegralOps extends NumericOps
   Definition Classes
     Integral
2.  class NumericOps extends AnyRef
   Definition Classes
     Numeric
3.  class OrderingOps extends AnyRef

   This inner class defines comparison operators available for `T`.

   This inner class defines comparison operators available for `T`.

   Definition Classes
     Ordering

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
4.  def abs(x: Char): Char
   Definition Classes
     Numeric
5.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

6.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
   Note

     not specified by SLS as a member of AnyRef

7.  def compare(x: Char, y: Char): Int

   Returns an integer whose sign communicates how x compares to y.

   Returns an integer whose sign communicates how x compares to y.

   The result sign has the following meaning:

   - negative if x < y
   - positive if x > y
   - zero otherwise (if x == y)
   Definition Classes
     CharOrdering → Ordering → Comparator
8.  final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`that`) is a reference to the receiver object (`this`).

   Tests whether the argument (`that`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef
9.  def equals(arg0: AnyRef): Boolean

   The equality method for reference types.

   The equality method for reference types. Default implementation delegates to `eq`.

   See also `equals` in scala.Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
10.  def equiv(x: Char, y: Char): Boolean

    Return true if `x` == `y` in the ordering.

    Return true if `x` == `y` in the ordering.

    Definition Classes
      Ordering → PartialOrdering → Equiv
11.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

12.  def fromInt(x: Int): Char
    Definition Classes
      CharIsIntegral → Numeric
13.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
14.  def gt(x: Char, y: Char): Boolean

    Return true if `x` > `y` in the ordering.

    Return true if `x` > `y` in the ordering.

    Definition Classes
      Ordering → PartialOrdering
15.  def gteq(x: Char, y: Char): Boolean

    Return true if `x` >= `y` in the ordering.

    Return true if `x` >= `y` in the ordering.

    Definition Classes
      Ordering → PartialOrdering
16.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
17.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
18.  def isReverseOf(other: Ordering[_]): Boolean

    Returns whether or not the other ordering is the opposite ordering of this one.

    Returns whether or not the other ordering is the opposite ordering of this one.

    Equivalent to `other == this.reverse`.

    Implementations should only override this method if they are overriding reverse as well.

    Definition Classes
      Ordering
19.  def lt(x: Char, y: Char): Boolean

    Return true if `x` < `y` in the ordering.

    Return true if `x` < `y` in the ordering.

    Definition Classes
      Ordering → PartialOrdering
20.  def lteq(x: Char, y: Char): Boolean

    Return true if `x` <= `y` in the ordering.

    Return true if `x` <= `y` in the ordering.

    Definition Classes
      Ordering → PartialOrdering
21.  def max[U <: Char](x: U, y: U): U

    Return `x` if `x` >= `y`, otherwise `y`.

    Return `x` if `x` >= `y`, otherwise `y`.

    Definition Classes
      Ordering
22.  def min[U <: Char](x: U, y: U): U

    Return `x` if `x` <= `y`, otherwise `y`.

    Return `x` if `x` <= `y`, otherwise `y`.

    Definition Classes
      Ordering
23.  def minus(x: Char, y: Char): Char
    Definition Classes
      CharIsIntegral → Numeric
24.  implicit def mkNumericOps(lhs: Char): IntegralOps
    Definition Classes
      Integral → Numeric
25.  implicit def mkOrderingOps(lhs: Char): OrderingOps

    This implicit method augments `T` with the comparison operators defined in `scala.math.Ordering.Ops`.

    This implicit method augments `T` with the comparison operators defined in `scala.math.Ordering.Ops`.

    Definition Classes
      Ordering
26.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
27.  def negate(x: Char): Char
    Definition Classes
      CharIsIntegral → Numeric
28.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

29.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

30.  def on[U](f: (U) => Char): Ordering[U]

    Given f, a function from U into T, creates an Ordering[U] whose compare function is equivalent to:

    Given f, a function from U into T, creates an Ordering[U] whose compare function is equivalent to:

        def compare(x:U, y:U) = Ordering[T].compare(f(x), f(y))

    Definition Classes
      Ordering
31.  def one: Char
    Definition Classes
      Numeric
32.  def orElse(other: Ordering[Char]): Ordering[Char]

    Creates an Ordering[T] whose compare function returns the result of this Ordering's compare function, if it is non-zero, or else the result of `other`s compare function.

    Creates an Ordering[T] whose compare function returns the result of this Ordering's compare function, if it is non-zero, or else the result of `other`s compare function.

    other

      an Ordering to use if this Ordering returns zero

    Definition Classes
      Ordering
    Example:

    1.     case class Pair(a: Int, b: Int)

           val pairOrdering = Ordering.by[Pair, Int](_.a)
                                      .orElse(Ordering.by[Pair, Int](_.b))

33.  def orElseBy[S](f: (Char) => S)(implicit ord: Ordering[S]): Ordering[Char]

    Given f, a function from T into S, creates an Ordering[T] whose compare function returns the result of this Ordering's compare function, if it is non-zero, or else a result equivalent to:

    Given f, a function from T into S, creates an Ordering[T] whose compare function returns the result of this Ordering's compare function, if it is non-zero, or else a result equivalent to:

        Ordering[S].compare(f(x), f(y))

    This function is equivalent to passing the result of `Ordering.by(f)` to `orElse`.

    Definition Classes
      Ordering
    Example:

    1.     case class Pair(a: Int, b: Int)

           val pairOrdering = Ordering.by[Pair, Int](_.a)
                                      .orElseBy[Int](_.b)

34.  def parseString(str: String): Option[Char]
    Definition Classes
      CharIsIntegral → Numeric
35.  def plus(x: Char, y: Char): Char
    Definition Classes
      CharIsIntegral → Numeric
36.  def quot(x: Char, y: Char): Char
    Definition Classes
      CharIsIntegral → Integral
37.  def rem(x: Char, y: Char): Char
    Definition Classes
      CharIsIntegral → Integral
38.  def reverse: Ordering[Char]

    Return the opposite ordering of this one.

    Return the opposite ordering of this one.

    Implementations overriding this method MUST override isReverseOf as well if they change the behavior at all (for example, caching does not require overriding it).

    Definition Classes
      Ordering → PartialOrdering
39.  def reversed(): Comparator[Char]
    Definition Classes
      Comparator
40.  def sign(x: Char): Char
    Definition Classes
      CharIsIntegral → Numeric
41.  def signum(x: Char): Int
    Definition Classes
      CharIsIntegral → Numeric
42.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
43.  def thenComparing[U <: Comparable[_ >: U <: AnyRef]](arg0: java.util.function.Function[_ >: Char <: AnyRef, _ <: U]): Comparator[Char]
    Definition Classes
      Comparator
44.  def thenComparing[U <: AnyRef](arg0: java.util.function.Function[_ >: Char <: AnyRef, _ <: U], arg1: Comparator[_ >: U <: AnyRef]): Comparator[Char]
    Definition Classes
      Comparator
45.  def thenComparing(arg0: Comparator[_ >: Char <: AnyRef]): Comparator[Char]
    Definition Classes
      Comparator
46.  def thenComparingDouble(arg0: ToDoubleFunction[_ >: Char <: AnyRef]): Comparator[Char]
    Definition Classes
      Comparator
47.  def thenComparingInt(arg0: ToIntFunction[_ >: Char <: AnyRef]): Comparator[Char]
    Definition Classes
      Comparator
48.  def thenComparingLong(arg0: ToLongFunction[_ >: Char <: AnyRef]): Comparator[Char]
    Definition Classes
      Comparator
49.  def times(x: Char, y: Char): Char
    Definition Classes
      CharIsIntegral → Numeric
50.  def toDouble(x: Char): Double
    Definition Classes
      CharIsIntegral → Numeric
51.  def toFloat(x: Char): Float
    Definition Classes
      CharIsIntegral → Numeric
52.  def toInt(x: Char): Int
    Definition Classes
      CharIsIntegral → Numeric
53.  def toLong(x: Char): Long
    Definition Classes
      CharIsIntegral → Numeric
54.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
55.  def tryCompare(x: Char, y: Char): Some[Int]

    Returns whether a comparison between `x` and `y` is defined, and if so the result of `compare(x, y)`.

    Returns whether a comparison between `x` and `y` is defined, and if so the result of `compare(x, y)`.

    Definition Classes
      Ordering → PartialOrdering
56.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
57.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
58.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
59.  def zero: Char
    Definition Classes
      Numeric

### Inherited from CharOrdering

### Inherited from CharIsIntegral

### Inherited from Integral[Char]

### Inherited from Numeric[Char]

### Inherited from Ordering[Char]

### Inherited from PartialOrdering[Char]

### Inherited from Equiv[Char]

### Inherited from java.io.Serializable

### Inherited from Comparator[Char]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped